#property indicator_separate_window
#property indicator_minimum -1.2
#property indicator_maximum 1.2
#property indicator_buffers 4
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_width1 4
#property indicator_width2 4

extern int CycleA = 3;
extern int CycleB = 2;
extern int CycleC = 1;
extern int wUpdate  = 60; //   
extern bool UseSound=true;
extern bool AlertSound=true;
extern string SoundFileBuy ="tada.wav";
extern string SoundFileSell="email.wav";
extern bool SendMailPossible = false;
extern int SIGNAL_BAR =  1 ; 
bool SoundBuy  = False;
bool SoundSell = False;
double arr_Up[];
double arr_Dn[];
double dot_Up[];
double dot_Dn[];
double ma = 0.0;
double g1 = 0.0;
double g2 = 0.0;
double g3 = 0.0;
int fl_1 = 0;
int fl_2 = 0;
int b1 = 0;
int b2 = 0;
double maP1 = 0.0;
double maS1 = 0.0;
int c1 = 1;
int c2 = 1;
double maP2 = 0.0;
double maS2 = 0.0;
int nn1 = 0;
int nn2 = 0;
int maF1;
int maF2;
int kUpdate;
int nStart=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init() 
  {
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,arr_Up);

   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,arr_Dn);

   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,dot_Up);

   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,dot_Dn);

   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);

   IndicatorShortName("FTS");
   kUpdate=1000*wUpdate;
   nStart=GetTickCount();
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() 
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start() 
  {
   int j;
   int im;
   int h;
   double ma_1;
   double ma_2;
   double ma_3;
   double ma_4;
   int limit;
   int limit_m;
   double ss;
   double HL;
   limit_m=100;
   if(IndicatorCounted()<0) return(-1);
   if((GetTickCount()-nStart) >= kUpdate)
   {
     limit=Bars;
     ma = 0.0;
     g1 = 0.0;
     g2 = 0.0;
     g3 = 0.0;
     fl_1 = 0;
     fl_2 = 0;
     b1 = 0;
     b2 = 0;
     maP1 = 0.0;
     maS1 = 0.0;
     c1 = 1;
     c2 = 1;
     maP2 = 0.0;
     maS2 = 0.0;
     nn1 = 0;
     nn2 = 0;
     nStart=GetTickCount();
   }else
   {
     limit=Bars-IndicatorCounted();
   }
   ss = 0.0;
   HL = 0.0;
   for(int i=limit;i>=0;i--) 
   {
      HL= 0.0;
      j = 0;
      for(int m=0;m<limit_m;m++) 
        {
         j++;
         im=i+m;
         if(im>=Bars) break;
         HL+=High[im]-Low[im];
        }
      ss= HL/j * CycleB;
      h = Bars-i;
      if(h<0) h=0;
      ma=iMA(NULL,0,CycleA,0,MODE_SMMA,PRICE_CLOSE,i);
      if(h<=1) 
        {
         if(g1==0.0) g2=ss;
         else g2=g1;
         maP1 = ma;
         maP2 = ma;
        }
      if(h>1) 
        {
         if(fl_1>-1) 
           {
            if(ma<maP1) 
              {
               dot_Up[i+h-c1]=0;
               maP1=ma;
               c1=h;
                 } else {
               if(ma>maP1) 
                 {
                  b1=h-c1;
                  dot_Up[i+b1]=-1;
                  ma_1 = iMA(NULL, 0, CycleA, 0, MODE_SMMA, PRICE_CLOSE, i + b1);
                  maF1 = ma - ma_1 >= g2;
                  if(maF1 && b1>=1) 
                    {
                     fl_1 = -1;
                     maP2 = ma;
                     nn1=h;
                    }
                 }
              }
           }
         if(fl_1<1) 
           {
            if(ma>maP2) 
              {
               dot_Dn[i+h-nn1]=0;
               maP2= ma;
               nn1 = h;
                 } else {
               if(ma<maP2) 
                 {
                  b1=h-nn1;
                  dot_Dn[i+b1]=1;
                  ma_2 = iMA(NULL, 0, CycleA, 0, MODE_SMMA, PRICE_CLOSE, i + b1);
                  maF1 = ma_2 - ma >= g2;
                  if(maF1 && b1>=1) 
                    {
                     fl_1 = 1;
                     maP1 = ma;
                     c1=h;
                    }
                 }
              }
           }
        }
      dot_Up[i] = 0;
      dot_Dn[i] = 0;
      if(h==1) 
        {
         if(g1==0.0) g3=ss*CycleC;
         else g3=g1*CycleC;
         maS1 = ma;
         maS2 = ma;
        }
      if(h>1) 
        {
         if(fl_2>-1) 
           {
            if(ma<maS1) 
              {
               arr_Up[i+h-c2]=0;
               maS1=ma;
               c2=h;
                 } else {
               if(ma>maS1) 
                 {
                  b2=h-c2;
                  arr_Up[i+b2]=-1;
                  ma_3 = iMA(NULL, 0, CycleA, 0, MODE_SMMA, PRICE_CLOSE, i + b2);
                  maF2 = ma - ma_3 >= g3;
                  if(maF2 && b2>=1) 
                    {
                     fl_2 = -1;
                     maS2 = ma;
                     nn2=h;
                    }
                 }
              }
           }
         if(fl_2<1) 
           {
            if(ma>maS2) 
              {
               arr_Dn[i+h-nn2]=0;
               maS2= ma;
               nn2 = h;
                 } else {
               if(ma<maS2) 
                 {
                  b2=h-nn2;
                  arr_Dn[i+b2]=1;
                  ma_4 = iMA(NULL, 0, CycleA, 0, MODE_SMMA, PRICE_CLOSE, i + b2);
                  maF2 = ma_4 - ma >= g3;
                  if(maF2 && b2>=1) 
                    {
                     fl_2 = 1;
                     maS1 = ma;
                     c2=h;
                    }
                 }
              }
           }
        }
      arr_Dn[i] = 0;
      arr_Up[i] = 0;
   }
 //+------------------------------------------------------------------+ 
        string  message  =  StringConcatenate("FTS (", Symbol(), ", ", Period(), ")  -  BUY!!!" ,"-" ,TimeToStr(TimeLocal(),TIME_SECONDS)); 
        string  message2 =  StringConcatenate("FTS (", Symbol(), ", ", Period(), ")  -  SELL!!!","-"  ,TimeToStr(TimeLocal(),TIME_SECONDS)); 
               
        if (arr_Up[SIGNAL_BAR] != EMPTY_VALUE && arr_Up[SIGNAL_BAR] != 0 && SoundBuy)
         {
         SoundBuy = False;
            if (UseSound) PlaySound (SoundFileBuy);
               if(AlertSound){         
               Alert(message);                             
               if (SendMailPossible) SendMail(Symbol(),message); 
            }              
         } 
      if (!SoundBuy && (arr_Up[SIGNAL_BAR] == EMPTY_VALUE || arr_Up[SIGNAL_BAR] == 0)) SoundBuy = True;  
            
  
     if (arr_Dn[SIGNAL_BAR] != EMPTY_VALUE && arr_Dn[SIGNAL_BAR] != 0 && SoundSell)
         {
         SoundSell = False;
            if (UseSound) PlaySound (SoundFileSell); 
             if(AlertSound){                    
             Alert(message2);             
             if (SendMailPossible) SendMail(Symbol(),message2); 
             }            
         } 
      if (!SoundSell && (arr_Dn[SIGNAL_BAR] == EMPTY_VALUE || arr_Dn[SIGNAL_BAR] == 0)) SoundSell = True; 
      
       //+------------------------------------------------------------------+  
   return(0);
  }
//+------------------------------------------------------------------+